; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur einen SLAVES zum messen auffordern										
;																				
;	INP: SRAM (adr_ROM_CRC_BEREICH)												
; 	OUT: CARRY																	
ONE_WIRE_MESSEN_DIREKT:
	; CRC- CHECK (der zu sendende ROM-ID)		
	rcall ONE_WIRE_ROM_CRC7					; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; FAMILY prfen								
	rcall ONE_WIRE_CHECK_TEMPERATURSENSOR	; OUT CARRY					
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE			; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; MASTER TX x55 (MATCH ROM)					
	ldi	temp1,0x55
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX 8 BYTE ROM CODE					
	LDS temp1,(adr_ROM_CRC_BEREICH+0)		; FAMILY CODE	
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+1)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+2)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+3)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+4)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+5)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+6)		; SERIAL NR		
	rcall ONE_WIRE_DATA_WRITE
	LDS temp1,(adr_ROM_CRC_BEREICH+7)		; CRC			
	rcall ONE_WIRE_DATA_WRITE
	rjmp ONE_WIRE_MESSUNG_ALLE_EINSPRUNGMARKE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; alle SLAVES zum Messen auffordern, Achtung Spannung am SENSOR bricht ein		
; bei zuvielen Sensoren und ungnstigen Kabelverhltnissen						
;																				
; OUT: CARRY																	
ONE_WIRE_MESSUNG_ALLE:
	;Reset und Presence-Test					
	rcall ONE_WIRE_RESET_PRESENCE			; OUT: CARRY				
	brcc ONE_WIRE_MESSUNG_ALLE_ERROR				; CARRY=0 ==> SPRUNG		
	; MASTER TX xCC (skip ROM)					
	ldi	temp1,0xCC			
	rcall ONE_WIRE_DATA_WRITE	
;-------------------------------------------------------------------------------
ONE_WIRE_MESSUNG_ALLE_EINSPRUNGMARKE:
	; MASTER TX x44 (convert T)					
	ldi	temp1,0x44
	rcall ONE_WIRE_DATA_WRITE	
	; voll POWER (strong pullup )				
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 	
	sbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF AUSGANG	
	rcall ONE_WIRE_WAIT_5us					; PAUSE			
	; PIN muss HIGH sein, bei LOW ev. berlastung am PIN (oder anderes HARDWAREPROBLEM)
	sbis (ONE_WIRE_PIN),(ONE_WIRE_PORTBIT) 	; "skip if..."
	rjmp ONE_WIRE_MESSUNG_ALLE_ERROR
	; Pause 									
	cbi PORTD,LED_D_GELB	; GELB 	
	sbi PORTD,LED_D_GRUEN	; GRN	
	rcall WAIT_1s
	cbi PORTD,LED_D_GRUEN	; GRN	
	sbi PORTD,LED_D_GELB	; GELB 	
	; CARRY setzen								
	SEC
	ret
;-------------------------------------------------------------------------------
ONE_WIRE_MESSUNG_ALLE_ERROR:
	; ERROR					
	ldi temp,(ERROR_MESSEN)					; CODE				
	rcall ERROR_SPEICHERN					; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

