; ##############################################################################
; ##############################################################################
; ##############################################################################
; ROM auslesen, nur ein SLAVE vorhanden !										
;																				
; OUT: CARRY, SRAM (adr_ROM_CRC_BEREICH)										
;																				
ONE_WIRE_SLAVE_SINGLE_ROM_READ:
	; CLEAR										
	rcall ONE_WIRE_CLEAR_ROM
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE				; OUT: CARRY		
	brcc ONE_WIRE_SLAVE_SINGLE_ROM_READ_ERROR	; CARRY=0 ==> SPRUNG		
	; MASTER TX x33 (read ROM)					
	ldi	temp1,0x33			
	rcall ONE_WIRE_DATA_WRITE
	; MASTER RX 8 BYTE und im SRAM ablegen		
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+0),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+1),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+2),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+3),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+4),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+5),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+6),temp1
	rcall ONE_WIRE_DATA_READ
	STS(adr_ROM_CRC_BEREICH+7),temp1
	; ROM CRC- CHECK							
	rcall ONE_WIRE_ROM_CRC7						; OUT: CARRY		
	brcc ONE_WIRE_SLAVE_SINGLE_ROM_READ_ERROR	; CARRY=0 ==> SPRUNG		
	; CARRY setzen			
	SEC
	ret
ONE_WIRE_SLAVE_SINGLE_ROM_READ_ERROR:
	; ERROR					
	ldi temp,(ERROR_SINGLE_ROM_READ); CODE				
	rcall ERROR_SPEICHERN			; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; SCRATCHPAD auslesen, nur ein SLAVE vorhanden !								
;																				
; OUT: CARRY, SRAM (adr_SCRATCHPAD_CRC_BEREICH)									
;																				
ONE_WIRE_SLAVE_SINGLE_SCRATCHPAD_READ:
	; CLEAR												
	rcall ONE_WIRE_CLEAR_SCRATCHPAD
	; RESET												
	rcall ONE_WIRE_RESET_PRESENCE						; OUT: CARRY		
	brcc ONE_WIRE_SLAVE_SINGLE_SCRATCHPAD_READ_ERROR	; CARRY=0 ==> SPRUNG		
	; MASTER TX xCC (SKIP ROM)							
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX xBE (read SCRATCHPAD)					
	rcall ONE_WIRE_SCRATCHPAD_READ_SINGLE_MARKE			; OUT: (CRC)				
	brcc ONE_WIRE_SLAVE_SINGLE_SCRATCHPAD_READ_ERROR	; CARRY=0 ==> SPRUNG		
	; CARRY setzen			
	SEC
	ret
ONE_WIRE_SLAVE_SINGLE_SCRATCHPAD_READ_ERROR:
	; ERROR					
	ldi temp,(ERROR_SINGLE_SCRATCHPAD_READ)	; CODE				
	rcall ERROR_SPEICHERN					; inp temp (CODE)	
	; CARRY clear			
	CLC
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;  nur ein SLAVE vorhanden !													
;																				
; EEPROM ins SCRATCHPAD , vorsicht, alle Sensoren knnen hiermit gleichzeitig	
; beschrieben werden															
;																				
ONE_WIRE_SLAVE_SINGLE_COPPY_EEPROM_SCRATCHPAD:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX xB8 (COPPY EEPROM in SCRATCHPAD)
	ldi	temp1,0xB8			
	rcall ONE_WIRE_DATA_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; nur ein SLAVE vorhanden !														
;																				
; SCRATCHPAD ins EEPROM , vorsicht, alle Sensoren knnen hiermit gleichzeitig	
; beschrieben werden															
;																				
ONE_WIRE_SLAVE_SINGLE_COPPY_SCRATCHPAD_EEPROM:
	; RESET										
	rcall ONE_WIRE_RESET_PRESENCE
	; MASTER TX xCC (SKIP ROM)					
	ldi	temp1,0xCC
	rcall ONE_WIRE_DATA_WRITE
	; MASTER TX x48 (COPPY SCRATCHPAD in EEPROM)
	ldi	temp1,0x48			
	rcall ONE_WIRE_DATA_WRITE
	; voll POWER (strong pullup )				
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 	
	sbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF AUSGANG	
	; Pause 									
	rcall WAIT_1s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
